Index: waeup/trunk/src/waeup/__init__.py
===================================================================
--- waeup/trunk/src/waeup/__init__.py	(revision 3551)
+++ waeup/trunk/src/waeup/__init__.py	(revision 4789)
@@ -0,0 +1,13 @@
+import grok
+from waeup.interfaces import IWAeUPObject
+from zope.annotation.attribute import AttributeAnnotations
+from zope.annotation.interfaces import IAnnotations
+
+class WAeUPAttributeAnnotations(AttributeAnnotations, grok.Adapter):
+    """An adapter to IAnnotations for any WAeUPObject.
+
+    Providing this adapter, each WAeUP object becomes (attribute)
+    annotatable.
+    """
+    grok.provides(IAnnotations)
+    grok.context(IWAeUPObject)
Index: waeup/trunk/src/waeup/app.py
===================================================================
--- waeup/trunk/src/waeup/app.py	(revision 3551)
+++ waeup/trunk/src/waeup/app.py	(revision 4789)
@@ -1,23 +1,31 @@
 import grok
-from grok import index
-from zope.interface import Interface
-from interfaces import IUniversity
-from setup import app_setup
-from viewlets import MainArea
+from zope.app.authentication.authentication import PluggableAuthentication
+from zope.app.security.interfaces import IAuthentication
+from zope.component import createObject
+
+from waeup.interfaces import IUniversity, ICSVDataReceivers
+from waeup.authentication import setup_authentication
+from waeup.datacenter import DataCenter
+from waeup.users import UserContainer
 
 class University(grok.Application, grok.Container):
-    grok.implements(IUniversity)
-
-    def __init__(self, name=u'Unnamed', **kw):
+    """A university.
+    """
+    grok.implements(IUniversity, ICSVDataReceivers)
+    # Setup authentication for this app. Note: this is only
+    # initialized, when a new instance of this app is created.
+    grok.local_utility(
+        PluggableAuthentication, provides = IAuthentication,
+        setup = setup_authentication)
+    
+    def __init__(self, name=u'Sample University', **kw):
         super(University, self).__init__(**kw)
         self.name = name
-        app_setup.setup(self)
+        self.setup()
 
-class Content(grok.Viewlet):
-    grok.viewletmanager(MainArea)
-    grok.context(IUniversity)
-
-
-class Edit(grok.EditForm):
-    grok.context(University)
-    grok.AutoFields(IUniversity)
+    def setup(self):
+        self['students'] = createObject(u'waeup.StudentContainer')
+        self['hostels'] = createObject(u'waeup.HostelContainer')
+        self['faculties'] = createObject(u'waeup.FacultyContainer')
+        self['users'] = UserContainer()
+        self['datacenter'] = DataCenter()
Index: waeup/trunk/src/waeup/authentication.py
===================================================================
--- waeup/trunk/src/waeup/authentication.py	(revision 4789)
+++ waeup/trunk/src/waeup/authentication.py	(revision 4789)
@@ -0,0 +1,143 @@
+"""Authentication for WAeUP portals.
+"""
+import grok
+from zope.app.authentication.session import SessionCredentialsPlugin
+from zope.app.authentication.interfaces import (ICredentialsPlugin,
+                                                IAuthenticatorPlugin,
+                                                IPrincipalInfo,
+                                                IPasswordManager)
+from zope.component import getUtility
+from zope.securitypolicy.interfaces import IPrincipalRoleManager
+from zope.securitypolicy.principalrole import principalRoleManager
+from waeup.interfaces import IUserAccount
+import waeup.permissions
+
+def setup_authentication(pau):
+    """Set up plugguble authentication utility.
+
+    Sets up an IAuthenticatorPlugin and
+    ICredentialsPlugin (for the authentication mechanism)
+    """
+    pau.credentialsPlugins = ['No Challenge if Authenticated', 'credentials']
+    pau.authenticatorPlugins = ['users']
+
+class WAeUPSessionCredentialsPlugin(grok.GlobalUtility,
+                                    SessionCredentialsPlugin):
+    grok.provides(ICredentialsPlugin)
+    grok.name('credentials')
+
+    loginpagename = 'login'
+    loginfield = 'form.login'
+    passwordfield = 'form.password'
+
+class PrincipalInfo(object):
+    grok.implements(IPrincipalInfo)
+
+    def __init__(self, id, title, description):
+        self.id = id
+        self.title = title
+        self.description = description
+        self.credentialsPlugin = None
+        self.authenticatorPlugin = None
+
+class Account(grok.Model):
+    grok.implements(IUserAccount)
+
+
+    def __init__(self, name, password, title=None, description=None,
+                 roles = []):
+        self.name = name
+        if title is None:
+            title = name
+        if description is None:
+            description = title
+        self.title = title
+        self.description = description
+        self.setPassword(password)
+        self.setRoles(roles)
+
+    def setPassword(self, password):
+        passwordmanager = getUtility(IPasswordManager, 'SHA1')
+        self.password = passwordmanager.encodePassword(password)
+
+    def checkPassword(self, password):
+        passwordmanager = getUtility(IPasswordManager, 'SHA1')
+        return passwordmanager.checkPassword(self.password, password)
+
+    def getRoles(self):
+        prm = self._getPrincipalRoleManager()
+        roles = [x[0] for x in prm.getRolesForPrincipal(self.name)
+                 if x[0].startswith('waeup.')]
+        return roles
+    
+    def setRoles(self, roles):
+        prm = self._getPrincipalRoleManager()
+        
+        old_roles = self.getRoles()
+        for role in old_roles:
+            # Remove old roles, not to be set now...
+            if role.startswith('waeup.') and role not in roles:
+                prm.unsetRoleForPrincipal(role, self.name)
+
+        for role in roles:
+            prm.assignRoleToPrincipal(role, self.name)
+
+    roles = property(getRoles, setRoles)
+
+    def _getPrincipalRoleManager(self):
+        portal = grok.getSite()
+        if portal is not None:
+            return IPrincipalRoleManager(portal)
+        return principalRoleManager
+        
+    
+class UserAuthenticatorPlugin(grok.GlobalUtility):
+    grok.provides(IAuthenticatorPlugin)
+    grok.name('users')
+
+    def authenticateCredentials(self, credentials):
+        if not isinstance(credentials, dict):
+            return None
+        if not ('login' in credentials and 'password' in credentials):
+            return None
+        account = self.getAccount(credentials['login'])
+
+        if account is None:
+            return None
+        if not account.checkPassword(credentials['password']):
+            return None
+        return PrincipalInfo(id=account.name,
+                             title=account.title,
+                             description=account.description)
+
+    def principalInfo(self, id):
+        account = self.getAccount(id)
+        if account is None:
+            return None
+        return PrincipalInfo(id=account.name,
+                             title=account.title,
+                             description=account.description)
+
+    def getAccount(self, login):
+        # ... look up the account object and return it ...
+        usercontainer = self.getUserContainer()
+        if usercontainer is None:
+            return
+        return usercontainer.get(login, None)
+
+    def addAccount(self, account):
+        usercontainer = self.getUserContainer()
+        if usercontainer is None:
+            return
+        # XXX: complain if name already exists...
+        usercontainer.addAccount(account)
+
+    def addUser(self, name, password, title=None, description=None):
+        usercontainer = self.getUserContainer()
+        if usercontainer is None:
+            return
+        usercontainer.addUser(name, password, title, description)
+        
+    def getUserContainer(self):
+        site = grok.getSite()
+        return site['users']
Index: waeup/trunk/src/waeup/browser/__init__.py
===================================================================
--- waeup/trunk/src/waeup/browser/__init__.py	(revision 4789)
+++ waeup/trunk/src/waeup/browser/__init__.py	(revision 4789)
@@ -0,0 +1,3 @@
+from waeup.browser.layout import (WAeUPPage, WAeUPLayout, WAeUPDisplayFormPage,
+                                  WAeUPEditFormPage, WAeUPAddFormPage,
+                                  NullValidator)
Index: waeup/trunk/src/waeup/browser/breadcrumbs.py
===================================================================
--- waeup/trunk/src/waeup/browser/breadcrumbs.py	(revision 4789)
+++ waeup/trunk/src/waeup/browser/breadcrumbs.py	(revision 4789)
@@ -0,0 +1,191 @@
+""" Components to get breadcrumbs for any object.
+"""
+import grok
+from grokcore.view.interfaces import IGrokView
+from zope.component import getAdapter
+from zope.publisher.browser import TestRequest
+
+from waeup import interfaces
+from waeup.browser.interfaces import (IBreadcrumb, IBreadcrumbIgnorable,
+                                      IBreadcrumbContainer)
+        
+class Breadcrumb(grok.Adapter):
+    """A most general breadcrumb generator.
+    """
+    grok.provides(IBreadcrumb)
+    grok.context(interfaces.IWAeUPObject)
+    grok.name('index')
+
+    _title = None
+    _parent = 0
+    _request = None
+    parent_viewname = 'index'
+    viewname = 'index'
+    
+    def __init__(self, context):
+        """Turn a context into a breadcrumb.
+        """
+        self.context = context
+
+    @property
+    def title(self):
+        """Get a title for a context.
+        """
+        if self._title is not None:
+            return self._title
+        if hasattr(self.context, 'name'):
+            return self.context.name
+        if hasattr(self.context, 'title'):
+            return self.context.title
+        return None
+
+    @property
+    def parent(self):
+        """Get the contexts parent object and viewname or None.
+        """
+        if self._parent is None:
+            return None
+        if self._parent is not 0:
+            return (self._parent, self.parent_viewname)
+        
+        if self.viewname != 'index':
+            self._parent = self.context
+        else:
+            site = grok.getSite()
+            if self.context is not site:
+                self._parent = getattr(self.context, '__parent__', None)
+
+        if self._parent is not None:
+            return (self._parent, self.parent_viewname)
+        return None
+
+class UniversityBreadcrumb(Breadcrumb):
+    """A breadcrumb for university index pages.
+    """
+    grok.context(interfaces.IUniversity)
+    title = u'Home'
+    parent = None
+
+class FacultyContainerBreadcrumb(Breadcrumb):
+    """A breadcrumb for faculty containers.
+    """
+    grok.context(interfaces.IFacultyContainer)
+    title = u'Faculties'
+
+class AdministrationBreadcrumb(Breadcrumb):
+    """A breadcrumb for administration areas of University instances.
+    """
+    grok.context(interfaces.IUniversity)
+    grok.name('administration')
+    title = u'Administration'
+    viewname = 'administration'
+
+class UserContainerBreadcrumb(Breadcrumb):
+    """A breadcrumb for user containers.
+    """
+    grok.context(interfaces.IUserContainer)
+    title = u'Users'
+    parent_viewname = 'administration'
+
+class DataCenterBreadcrumb(Breadcrumb):
+    """A breadcrumb for data centers.
+    """ 
+    grok.context(interfaces.IDataCenter)
+    title = u'Data Center'
+    parent_viewname = 'administration'
+
+class FacultyBreadcrumb(Breadcrumb):
+    """A breadcrumb for faculties.
+    """
+    grok.context(interfaces.IFaculty)
+    
+    @property
+    def title(self):
+        prefix = self.context.title_prefix
+        prefix = prefix[0].upper() + prefix[1:]
+        return '%s of %s' % (prefix, self.context.title)
+
+class DepartmentBreadcrumb(FacultyBreadcrumb):
+    """A breadcrumb for departments.
+    """
+    grok.context(interfaces.IDepartment)
+
+class CourseContainerBreadcrumb(Breadcrumb):
+    """ We don't want course container breadcrumbs.
+    """
+    grok.context(interfaces.ICourseContainer)
+    grok.implements(IBreadcrumbIgnorable)
+
+class CertificateContainerBreadcrumb(Breadcrumb):
+    """ We don't want course container breadcrumbs.
+    """
+    grok.context(interfaces.ICertificateContainer)
+    grok.implements(IBreadcrumbIgnorable)
+
+class CertificateCourseBreadcrumb(Breadcrumb):
+    """ We don't want course container breadcrumbs.
+    """
+    grok.context(interfaces.ICertificateCourse)
+    @property
+    def title(self):
+        return self.context.course.title
+
+def getBreadcrumb(obj, viewname=None):
+    """ Get a breadcrumb for an object and a viewname.
+
+    If there is no breadcrumb defined for such a combination, a
+    breadcrumb for the ``index`` view will be looked up.
+    """
+    try:
+        return getAdapter(obj, IBreadcrumb, name=viewname)
+    except:
+        pass
+    return getAdapter(obj, IBreadcrumb, name='index')
+
+def getBreadcrumbList(obj, viewname):
+    """Get an ordered list of breadcrumbs for an object and a viewname.
+
+    Ignorables are excluded from the result.
+    """
+    current = getBreadcrumb(obj, viewname)
+    result = [current]
+    while current.parent is not None:
+        context, viewname = current.parent
+        current = getBreadcrumb(context, viewname)
+        if IBreadcrumbIgnorable.providedBy(current):
+            # Ignore empty breadcrumbs...
+            continue
+        result.append(current)
+    result.reverse()
+    return result
+
+def getBreadcrumbListForView(view):
+    """Get an ordered list of breadcrumbs a certain view.
+
+    Ignorables are excluded from the result.
+    """
+    context = getattr(view, 'context')
+    viewname = getattr(view, '__name__')
+    return getBreadcrumbList(context, viewname)
+
+class BreadcrumbContainer(grok.Adapter):
+    """An adapter to adapt grok views to list of breadcrumbs.
+    """
+    grok.context(IGrokView)
+    grok.provides(IBreadcrumbContainer)
+
+    _breadcrumbs = None
+    
+    def __init__(self, context):
+        self.context = context
+        self._breadcrumbs = getBreadcrumbListForView(self.context)
+
+    def __iter__(self):
+        """Allow iteration.
+        """
+        return self._breadcrumbs.__iter__()
+
+    def getList(self):
+        """Get the (ordered) list of breadcrumbs liked to the context view.
+        """
+        return self._breadcrumbs
Index: waeup/trunk/src/waeup/browser/interfaces.py
===================================================================
--- waeup/trunk/src/waeup/browser/interfaces.py	(revision 4789)
+++ waeup/trunk/src/waeup/browser/interfaces.py	(revision 4789)
@@ -0,0 +1,52 @@
+"""Interfaces for viewing components.
+"""
+from zope import schema
+from zope.interface import Interface, Attribute
+
+
+class IBreadcrumb(Interface):
+    """Provide breadcrumbs.
+    """
+    title = schema.TextLine(
+        title = u'Context description',
+        readonly = True,
+        )
+    viewname = schema.TextLine(
+        title = u'The viewname, for which the breadcrumb is provided.',
+        readonly = True,
+        default = u'index'
+        )
+    parent_viewname = schema.TextLine(
+        title = u'The viewname of the parent to use.',
+        readonly = True,
+        default = u'index'
+        )
+    parent = Attribute("The parent object.")
+    context = Attribute("The context of the breadcrumb.")
+
+
+    def getURL(view=None):
+        """Return a URL to the breadcrumb target.
+        """
+
+class IBreadcrumbIgnorable(Interface):
+    """A marker interface for breadcrumbs that should be skipped in output.
+
+    If a breadcrumb wants to be skipped in real output (for instance,
+    because it is set on a layer in site hierarchy that should not be
+    accessed by users), it can also provide this interface. The
+    getBreadcrumbList() function defined here will exclude IIgnorables
+    by default.
+    """
+    pass
+
+class IBreadcrumbContainer(Interface):
+    """A container of breadcrumbs.
+    """
+    def __iter__():
+        """Allow iteration over the container.
+        """
+
+    def getList():
+        """Get the list of breadcrumbs as real Python list.
+        """
Index: waeup/trunk/src/waeup/browser/layout.py
===================================================================
--- waeup/trunk/src/waeup/browser/layout.py	(revision 4789)
+++ waeup/trunk/src/waeup/browser/layout.py	(revision 4789)
@@ -0,0 +1,107 @@
+"""Basic layout components.
+"""
+import grok
+from hurry import yui
+from megrok.layout import Page, Layout, EditForm, DisplayForm, AddForm
+from waeup.interfaces import IWAeUPObject
+from z3c.flashmessage.interfaces import IMessageSource
+from zope.component import queryUtility, ComponentLookupError
+from zope.interface import Interface
+# Conditional import. getSite moved to zope.site.hooks in recent grok versions.
+try:
+    from zope.site.hooks import getSite
+except ImportError:
+    from zope.app.component.hooks import getSite
+
+grok.templatedir('templates')
+
+def NullValidator(*args, **kw):
+    """A validator that does not validate.
+
+    This is needed especially for cancel buttons. We don't want data
+    to be validated that will be thrown away in the next step.
+
+    You can use it with ``grok.action`` decorator like this::
+
+      @grok.action('Cancel', validator=NullValidator)
+      def cancel(self, **data):
+        self.redirect(<whereever-you-go>)
+    """
+    return dict()
+
+class UtilityView(object):
+    """A view mixin with useful methods.
+
+    The ``pnav`` attribute (a number) tells, to which primary
+    navigation tab a page declares to belong.
+    """
+    title = u'' # What appears in the content title...
+    pnav = 0 # Primary navigation index...
+    
+    def application_url(self, name=None):
+        """Return the URL of the nearest site.
+        """
+        site = getSite()
+        #if not site:
+        #    raise ComponentLookupError("No site found.")
+        return self.url(site, name)
+
+    def flash(self, message, type='message'):
+        """Send a short message to the user.
+        """
+        source = queryUtility(IMessageSource, name='session')
+        if source is None:
+            return None
+        source.send(message, type)
+        return True
+
+class WAeUPLayout(Layout, UtilityView):
+    """A megrok.layout.Layout with additional methods.
+    """
+    grok.baseclass()
+    
+class WAeUPPage(Page, UtilityView):
+    """A megrok.layout page with additional methods.
+    """
+    grok.baseclass()
+
+class WAeUPDisplayFormPage(DisplayForm, UtilityView):
+    """A megrok.layout.DisplayForm with additional methods.
+    """
+    grok.baseclass()
+
+class WAeUPEditFormPage(EditForm, UtilityView):
+    """A megrok.layout.EditForm with additional methods.
+    """
+    grok.baseclass()
+
+class WAeUPAddFormPage(AddForm,  UtilityView):
+    """A megrok.layout.AddForm with additional methods.
+    """
+    grok.baseclass()
+
+class SiteLayout(WAeUPLayout):
+    """ The general site layout.
+    """
+    grok.context(IWAeUPObject)
+
+    def getAppTitle(self):
+        return getattr(grok.getSite(), 'name', u'Sample University')
+    
+    def isAuthenticated(self):
+        """Return True if the calling user is authenticated.
+        """
+        usertitle = self.request.principal.title
+        return usertitle != 'Unauthenticated User'
+    
+    def getUserTitle(self):
+        """Return principal title of current user.
+        """
+        usertitle = self.request.principal.title
+        if usertitle == 'Unauthenticated User':
+            return u''
+        return usertitle
+
+    def update(self):
+        yui.reset_fonts_grids.need()
+        yui.sam.need()
